﻿using PP_Ven_MosS.ModelBase;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PP_Ven_MosS.Classes;

namespace PP_Ven_MosS.Pages
{
    /// <summary>
    /// Логика взаимодействия для ApplicationsListAdmin.xaml
    /// </summary>
    public partial class ApplicationsListAdmin
    {
       User user = new User();
        private string evtype;
        public string EventType 
        {
            get { return evtype; }
            set {  evtype = value; }
        }

        private string apptype;

        public string ApplicType
        {
            get { return apptype; }
            set { apptype = value; }
        }
    }
    public partial class ApplicationsListAdmin : Page
    {
        PP_MininEntities2 DB = new PP_MininEntities2();
        int id;
        public ApplicationsListAdmin()
        { 
            
            InitializeComponent();
           
            ApplicationList.ItemsSource = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            CB_Filter_app.ItemsSource = new List<string> { "Фильтр по статусу", "Выполнен", "Не выполнен" };
            CB_Sort_app.ItemsSource = new List<string>() { "Фильтр по дате","Не сегодня", "Сегодня" };
            CB_Sort_app.SelectedIndex = 0;
            CB_Filter_app.SelectedIndex = 0;
            
            EventList.ItemsSource = DB.Event.ToList();
            Event evnt = DB.Event.Where(x => x.Id_event == id).FirstOrDefault();
            CB_Filter_event.ItemsSource = new List<string>() { "Фильтр по статусу", "Проведено", "Не проведено" };
            CB_Sort_event.ItemsSource = new List<string>() { "Фильтр по дате", "Не сегодня", "Сегодня" };
            CB_Sort_event.SelectedIndex = 0;
            CB_Filter_event.SelectedIndex = 0;
        }
        public ApplicationsListAdmin(int id)
        {
            InitializeComponent();
            ApplicationList.ItemsSource = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            CB_Filter_app.ItemsSource = DB.Applications.ToList() ; 
            CB_Sort_app.ItemsSource = DB.Applications.ToList() ;
            CB_Sort_app.SelectedIndex = 0;
            CB_Filter_app.SelectedIndex = 0;
            this.id = id;

            EventList.ItemsSource = DB.Event.ToList();
            Event evnt = DB.Event.Where(x => x.Id_event == id).FirstOrDefault();
            CB_Filter_event.ItemsSource = new List<string>() ;
            CB_Sort_event.ItemsSource = new List<string>() ;
            CB_Sort_event.SelectedIndex = 0;
            CB_Filter_event.SelectedIndex = 0;
            this.id = id;
        }
        private void TF_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int id = Convert.ToInt32(cb.Uid);
            Applications applications = Classes.Database.entities.Applications.Where(x => x.Id_employee == UserID.userid).FirstOrDefault();
            applications.Id_status_app = 1;
            user.Count_complete_app++;
            Classes.Database.entities.SaveChanges();
            FrameClass.MainFrame.Navigate(new ApplicationsListAdmin());
        }
        private void TFE_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cbe = (CheckBox)sender;
            int id = Convert.ToInt32(cbe.Uid);
            Event events = Classes.Database.entities.Event.FirstOrDefault(x => x.Id_event == id);
            events.Id_status_event = 1;
            user.Count_complete_event++;
            Classes.Database.entities.SaveChanges();
            FrameClass.MainFrame.Navigate(new ApplicationsListAdmin());
        }
        private void Filter()
        {
            List<Applications> applications = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            if (CB_Sort_app.SelectedIndex != 0)
            {
                switch (CB_Sort_app.SelectedIndex)
                {
                    case 1:
                        applications = applications.Where(x=>x.Date_app < DateTime.Today).OrderBy(x => x.Date_app).ToList();
                        break;
                    case 2:
                        applications = applications.Where(x => x.Date_app == DateTime.Today).OrderBy(x => x.Date_app).ToList();
                        break;
                }
            }
            if (CB_Filter_app.SelectedIndex != 0)
            {
                switch (CB_Filter_app.SelectedIndex)
                {
                    case 1:
                        applications = applications.Where(x => x.Id_status_app == 1).ToList();
                        break;
                    case 2:
                        applications = applications.Where(x => x.Id_status_app == 2).ToList();
                        break;
                }
            }
            if (!string.IsNullOrEmpty(TB_Search_app.Text))
            {
                applications = applications.Where(x => x.Description.ToUpper().Contains(TB_Search_app.Text.ToUpper())).ToList();
            }
            ApplicationList.ItemsSource = applications;
            //Мероприятия
            List<Event> events = DB.Event.ToList();
            if (CB_Sort_event.SelectedIndex != 0)
            {
                switch (CB_Sort_event.SelectedIndex)
                {
                    case 1:
                        events = events.Where(x => x.Date_event < DateTime.Today).OrderBy(x => x.Date_event).ToList();
                        break;
                    case 2:
                        events = events.Where(x => x.Date_event == DateTime.Today).OrderBy(x => x.Date_event).ToList();
                        break;
                }
            }
            if (CB_Filter_event.SelectedIndex != 0)
            {
                switch (CB_Filter_event.SelectedIndex)
                {
                    case 1:
                        events = events.Where(x => x.Id_status_event == 1).ToList();
                        break;
                    case 2:
                        events = events.Where(x => x.Id_status_event == 2).ToList();
                        break;
                }
            }
            if (!string.IsNullOrEmpty(TB_Search_event.Text))
            {
                events = events.Where(x => x.Title_event.ToUpper().Contains(TB_Search_event.Text.ToUpper())).ToList();
            }
            EventList.ItemsSource = events;
        }

        private void SortFilterChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void SearchChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }
        private void TB_Search_event_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void CB_Sort_event_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void CB_Filter_event_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }
        private void Exit_Click(object sender, RoutedEventArgs e)
        {
            FrameClass.MainFrame.Navigate(new Avtorization());
        }
        private void Profile_Click(object sender, RoutedEventArgs e)
        {

            FrameClass.MainFrame.Navigate(new Profile(user));
        }
    }
}